<template>
    <div class="alert" v-if="errorMessage">
        {{errorMessage}}
        <button type="button" @click="errorMessage=''">Close</button>
    </div>
    <form @submit.prevent="savePerson">
        <label>
            <span>First Name</span>
            <input type="text" required placeholder="Max" v-model="firstName">
        </label>
        <label>
            <span>Last Name</span>
            <input type="text" required placeholder="Muster" v-model="lastName">
        </label>
        <button type="submit">Speichern</button>
    </form>
    <p>Vorname: {{firstName}}</p>
    <p>Nachname: {{lastName}}</p>
    <PersonTable :persons="userStore.users" @delete="deletePerson" @edit="editPerson"/>
</template>

<script setup>
    import {ref} from "vue";
    import PersonTable from "@/components/PersonTable.vue";
    import axios from "axios";
    import {useUserStore} from "@/stores/UserStore";

    const firstName = ref('')
    const lastName = ref('')
    const userStore = useUserStore()
    const errorMessage = ref('')

    async function savePerson() {
        try {
            await userStore.saveUser({
                firstName: firstName.value,
                lastName: lastName.value,
                birthYear: 1990
            })
        } catch (err) {
            if(err.response.status === 400) {
                errorMessage.value = 'Ungültige Eingabe'
            } else {
                console.log(err)
                errorMessage.value = 'Ein unbekannter Fehler ist aufgetreten. Bitte versuchen Sie es später erneut'
            }
        }
        firstName.value = ''
        lastName.value = ''
    }

    function deletePerson(index) {
        console.log('Delete person in PersonForm.vue', index)
        userStore.users.splice(index, 1)
    }

    function editPerson(person, index) {
        console.log(person, index)
        userStore.users.splice(index, 1, person)
    }
</script>

<style scoped>
label span {
    font-weight: bold;
}
</style>